/**
 * Copyright (c) 2009-2012 EBM WebSourcing, 2012-2017 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see http://www.gnu.org/licenses/
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.jbi.servicedesc.endpoint;

import java.io.Serializable;

import javax.jbi.servicedesc.ServiceEndpoint;

/**
 * The petals service endpoint contains the JBI information and the localization.
 * 
 * @author Christophe Hamerling - EBM WebSourcing
 */
public interface PetalsServiceEndpoint extends ServiceEndpoint, Serializable {
    
    public static final String JBI_NAMESPACE = "http://java.sun.com/xml/ns/jbi";

    public static final String EPR_NAME = "endpoint-reference";

    public static final String SERVICE_NAME = "service-name";

    public static final String ENDPOINT_NAME = "endpoint-name";

    /**
     * local name for when interfaces can't be solved when creating an endpoint
     */
    public static final String UNRESOLVED_INTERFACE = "UNRESOLVED_INTERFACE";

    public enum EndpointType {
        EXTERNAL, INTERNAL
    }

    EndpointType getType();

    Location getLocation();
}
